VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "DBCounter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Public Sub Add()
    CounterCount = CounterCount + 1
    ReDim Preserve Counter(CounterCount) As CounterInfo
    
    With Counter(CounterCount)
        .CLoop = 1
        .Min1 = 0
        .Min2 = 0
        .Max1 = 0
        .Max2 = 0
        .Increment1 = 0
        .Increment2 = 0
        .CounterDone = False
        .Looping = True
        .On = False
        .Timer = 0
        .Timer1 = 1
        .Timer2 = 1
        .Value = 0
        .MLoop = 1
        .TotalLoops = 0
        .MaxLoops = 1
        .AutoOff = False
    End With
    
End Sub

Public Sub AddFromSource(SourceIndex As Integer)
    CounterCount = CounterCount + 1
    ReDim Preserve Counter(CounterCount) As CounterInfo
    
    Counter(CounterCount) = Counter(SourceIndex)
End Sub

Public Sub Swap(FromIndex As Integer, ToIndex As Integer)
    Counter(0) = Counter(FromIndex)
    Counter(FromIndex) = Counter(ToIndex)
    Counter(ToIndex) = Counter(0)
End Sub

Public Sub Copy(FromIndex As Integer, ToIndex As Integer)
    Counter(ToIndex) = Counter(FromIndex)
End Sub

Public Sub Clear()
    ReDim Counter(0) As CounterInfo
    CounterCount = 0
End Sub

Public Sub Remove(Index As Integer)
    Dim T As Integer
    If Index <> CounterCount Then
        For T = Index To CounterCount - 1
            Counter(T) = Counter(T + 1)
        Next T
        CounterCount = CounterCount - 1
        ReDim Preserve Counter(CounterCount) As CounterInfo
    Else:
        CounterCount = CounterCount - 1
        ReDim Preserve Counter(CounterCount) As CounterInfo
    End If
End Sub

Public Sub ClearCounter(Index As Integer)
    With Counter(Index)
        .CLoop = 1
        .Min1 = 0
        .Min2 = 0
        .Max1 = 0
        .Max2 = 0
        .Increment1 = 0
        .Increment2 = 0
        .CounterDone = False
        .Looping = True
        .On = False
        .Timer = 0
        .Timer1 = 1
        .Timer2 = 1
        .Value = 0
        .MLoop = 1
        .MaxLoops = 1
        .TotalLoops = 0
        .AutoOff = False
    End With
End Sub
Public Sub ResetCounter(Index As Integer, Optional KeepValue As Boolean)
    With Counter(Index)
        .CounterDone = False
        .Timer = 0
        .CLoop = 1
        If KeepValue = False Then
        .Value = .Min1
        End If
        .On = True
        .TotalLoops = 0
    End With
End Sub

Public Sub TurnOn(Index As Integer)
    Counter(Index).On = True
End Sub

Public Sub TurnOff(Index As Integer)
    Counter(Index).On = False
End Sub

Public Sub SetMin1(Index As Integer, Value As Integer)
    Counter(Index).Min1 = Value
End Sub
Public Sub SetMin2(Index As Integer, Value As Integer)
    Counter(Index).Min2 = Value
End Sub
Public Sub SetMax1(Index As Integer, Value As Integer)
    Counter(Index).Max1 = Value
End Sub
Public Sub SetMax2(Index As Integer, Value As Integer)
    Counter(Index).Max2 = Value
End Sub

Public Sub SetLooping(Index As Integer, Value As Boolean)
    Counter(Index).Looping = Value
End Sub

Public Sub SetIncrement1(Index As Integer, Value As Integer)
    If Value < 1 Then Value = 1
    Counter(Index).Increment1 = Value
End Sub
Public Sub SetIncrement2(Index As Integer, Value As Integer)
    If Value < 1 Then Value = 1
    Counter(Index).Increment2 = Value
End Sub

Public Sub SetTimer1(Index As Integer, Value As Integer)
    If Value < 1 Then Value = 1
    Counter(Index).Timer1 = Value
End Sub
Public Sub SetTimer2(Index As Integer, Value As Integer)
    If Value < 1 Then Value = 1
    Counter(Index).Timer2 = Value
End Sub

Public Sub SetValue(Index As Integer, Value As Integer)
    Counter(Index).Value = Value
End Sub

Public Sub SetLoopMethod(Index As Integer, Value As Integer)
    If Value < 1 Then Value = 1
    If Value > 2 Then Value = 2
    Counter(Index).MLoop = Value
End Sub

Public Sub SetMaxLoops(Index As Integer, Value As Integer)
    If Value < 1 Then Value = 1
    Counter(Index).MaxLoops = Value
End Sub

Public Sub SetAutoOff(Index As Integer, Value As Boolean)
    Counter(Index).AutoOff = Value
End Sub

Public Sub QMSetUpCounter2Loop(Index As Integer, Min1 As Integer, Max1 As Integer, Min2 As Integer, Max2 As Integer, Increment1 As Integer, Increment2 As Integer, Timer1 As Integer, Timer2 As Integer, MaxLoops As Integer, Looping As Boolean)
    If Increment1 < 1 Then Increment1 = 1
    If Increment2 < 1 Then Increment2 = 1
    If Timer1 < 1 Then Timer1 = 1
    If Timer2 < 1 Then Timer2 = 1
    If MaxLoops < 1 Then MaxLoops = 1
    With Counter(Index)
        .Min1 = Min1
        .Min2 = Min2
        .Max1 = Max1
        .Max2 = Max2
        .Increment1 = Increment1
        .Increment2 = Increment2
        .Timer1 = Timer1
        .Timer2 = Timer2
        .MaxLoops = MaxLoops
        .Looping = Looping
        .MLoop = 2
    End With
End Sub
Public Sub QMSetUpCounter1Loop(Index As Integer, Min1 As Integer, Max1 As Integer, Increment1 As Integer, Timer1 As Integer, MaxLoops As Integer, Looping As Boolean)
    If Increment1 < 1 Then Increment1 = 1
    If Timer1 < 1 Then Timer1 = 1
    If MaxLoops < 1 Then MaxLoops = 1
    With Counter(Index)
        .Min1 = Min1
        .Max1 = Max1
        .Increment1 = Increment1
        .Timer1 = Timer1
        .MaxLoops = MaxLoops
        .Looping = Looping
        .MLoop = 1
    End With
End Sub

Public Sub QMFlipMinMax1(Index As Integer, Optional ResetLoops As Boolean)
Dim Dummy As Integer
With Counter(Index)
    Dummy = .Min1
    .Min1 = .Max1
    .Max1 = Dummy
    If ResetLoops = True Then
    .TotalLoops = 0
    End If
End With
End Sub
Public Sub QMFlipMinMax2(Index As Integer, Optional ResetLoops As Boolean)
Dim Dummy As Integer
With Counter(Index)
    Dummy = .Min2
    .Min2 = .Max2
    .Max2 = Dummy
    If ResetLoops = True Then
    .TotalLoops = 0
    End If
End With
End Sub

Public Sub QMTransferValues(FromIndex As Integer, ToIndex As Integer)
    Counter(ToIndex).Value = Counter(FromIndex).Value
End Sub

Public Function GetMin1(Index As Integer) As Integer
    GetMin1 = Counter(Index).Min1
End Function
Public Function GetMin2(Index As Integer) As Integer
    GetMin2 = Counter(Index).Min2
End Function
Public Function GetMax1(Index As Integer) As Integer
    GetMax1 = Counter(Index).Max1
End Function
Public Function GetMax2(Index As Integer) As Integer
    GetMax2 = Counter(Index).Max2
End Function
Public Function GetIncrement1(Index As Integer) As Integer
    GetIncrement1 = Counter(Index).Increment1
End Function
Public Function GetIncrement2(Index As Integer) As Integer
    GetIncrement2 = Counter(Index).Increment2
End Function
Public Function GetTimer1(Index As Integer) As Integer
    GetTimer1 = Counter(Index).Timer1
End Function
Public Function GetTimer2(Index As Integer) As Integer
    GetTimer2 = Counter(Index).Timer2
End Function
Public Function GetLooping(Index As Integer) As Boolean
    GetLooping = Counter(Index).Looping
End Function
Public Function GetLoopMethod(Index As Integer) As Integer
    GetLoopMethod = Counter(Index).MLoop
End Function
Public Function GetMaxLoops(Index As Integer) As Integer
    GetMaxLoops = Counter(Index).MaxLoops
End Function
Public Function GetAutoOff(Index As Integer) As Boolean
    GetAutoOff = Counter(Index).AutoOff
End Function
Public Function GetOn(Index As Integer) As Boolean
    GetOn = Counter(Index).On
End Function

Public Function ReturnCounterDone(Index As Integer) As Boolean
    ReturnCounterDone = Counter(Index).CounterDone
End Function
Public Function ReturnCurrentMethod(Index As Integer) As Integer
    ReturnCurrentMethod = Counter(Index).CLoop
End Function
Public Function ReturnCurrentLoop(Index As Integer) As Integer
    ReturnCurrentLoop = Counter(Index).TotalLoops + 1
End Function
Public Function ReturnPositiveInteger(Index As Integer) As Integer
    ReturnPositiveInteger = Counter(Index).Value
End Function
Public Function ReturnNegativeInteger(Index As Integer) As Integer
    ReturnNegativeInteger = Counter(Index).Value * -1
End Function
Public Function ReturnPositiveSingle(Index As Integer) As Single
    ReturnPositiveSingle = Counter(Index).Value * 1
End Function
Public Function ReturnNegativeSingle(Index As Integer) As Single
    ReturnNegativeSingle = Counter(Index).Value * -1
End Function
Public Function ReturnMultiplicative(Index As Integer, Value As Single) As Single
    ReturnMultiplicative = Counter(Index).Value * Value
End Function
Public Function ReturnDivision(Index As Integer, Value As Single) As Single
    ReturnDivision = Counter(Index).Value / Value
End Function

Public Function GetCounterCount() As Integer
    GetCounterCount = CounterCount
End Function

Private Sub Class_Initialize()
ReDim Counter(0) As CounterInfo
End Sub

Private Sub Class_Terminate()
ReDim Counter(0) As CounterInfo
End Sub
